minix/commands/easypack/easypack.sh

110 lines
2.6 KiB
Bash
Raw Normal View History

2005-09-15 16:55:11 +02:00
#!/bin/sh
# This script gets and installs a package from the Website.
2006-08-15 17:57:13 +02:00
# It is called by easypack package1 ...
2005-09-15 16:55:11 +02:00
# A package must be in the form of pack.tar.bz2 and must
# include a build script that makes and installs it.
# The build script should succeed if installation works, else fail
# Examples:
# easypack awk elle telnet # fetch and install 3 packages
# easypack -o awk elle telnet # fetch and replace existing packs
2006-08-15 17:57:13 +02:00
SOURCE_DIR=/usr/local/src # where the source is deposited
2005-09-15 16:55:11 +02:00
OVERWRITE=0 # can an installed package be overwritten?
2006-08-15 17:57:13 +02:00
SOFTWARE_DIR="http://www.minix3.org/software"
2005-09-15 16:55:11 +02:00
# Check for at least one parameter
case $# in
0) echo Usage: $0 package ...
exit ;;
esac
# Change to source directory
ORIG_DIR=`pwd`
rm -f Log # remove old debugging log
2006-08-15 17:57:13 +02:00
mkdir $SOURCE_DIR || true
cd $SOURCE_DIR || exit
if [ "`id -u`" -ne 0 ]
then
# Check for write permission here
if test ! -w .
then echo You do not have write permission for $SOURCE_DIR
exit 1
fi
2005-09-15 16:55:11 +02:00
fi
# Check for -o flag; if found, set OVERWRITE
if test $1 = "-o"
then OVERWRITE=1
shift
fi
# Loop on the packages
for i
do # Check to see if it exists. Don't overwrite unless -o given
2005-11-02 13:05:01 +01:00
echo " " ; echo Start fetching package $i
2005-09-15 16:55:11 +02:00
echo " " >>$ORIG_DIR/Log
echo ------------- Start fetching $i ------------------ >>$ORIG_DIR/Log
if test -r $i
then # Directory already exists. May it be overwritten?
if test $OVERWRITE = 0
then echo $i already exists. Skipping this package
continue
else # Remove the directory
rm -rf $i
echo Existing directory $i removed
fi
fi
# Remove any junk from previous attempts
rm -f $i.tar.bz2 $i.tar
2005-09-15 16:55:11 +02:00
# Get the package
URL=$SOFTWARE_DIR/$i.tar.bz2
TARBZ=$i.tar.bz2
2006-02-21 17:06:28 +01:00
if urlget $URL >$TARBZ 2>/dev/null
then :
2006-08-15 17:57:13 +02:00
else
echo Cannot get $i.
echo " " Tried $URL
echo " " Skipping this package
rm -f $TARBZ
continue
2005-09-15 16:55:11 +02:00
fi
# We got it. Unpack it.
2005-11-02 21:01:37 +01:00
echo Package $i fetched
bunzip2 $TARBZ || smallbunzip2 $TARBZ
2006-08-15 17:57:13 +02:00
pax -r <$i.tar
2005-09-15 16:55:11 +02:00
if test ! -d $i
then echo Unable to unpack $i
continue
2005-11-02 13:05:01 +01:00
else echo Package $i unpacked
2005-09-15 16:55:11 +02:00
fi
# It is now unpacked. Build it
cd $i
if [ -f build.minix ]
then sh build.minix >>$ORIG_DIR/Log 2>&1
r=$?
else sh build >>$ORIG_DIR/Log 2>&1
r=$?
fi
if [ $r -eq 0 ]
2005-11-02 13:05:01 +01:00
then echo Package $i installed
2005-11-02 21:01:37 +01:00
else echo Package $i failed to install, see Log
2005-09-15 16:55:11 +02:00
fi
2006-03-22 20:39:26 +01:00
if [ -f .postinstall ]
then echo Running postinstall script.
sh -e .postinstall
fi
2005-09-15 16:55:11 +02:00
# Clean up
cd ..
rm -f $i.tar $TARBZ # Remove whatever is still lying around
2005-09-15 16:55:11 +02:00
done